package edu.uiuc.edsg;

import java.util.Iterator;

/**
 * java.util.Iterator used to iterate over all generated values in a foreach loop:
 * <code>for(ValueType value : generator) {...}</code>
 */
public class ForLoopIterator<ValueType> implements Iterator<ValueType> {

	private IGenerator<ValueType> _generator;
	
	public ForLoopIterator(IGenerator<ValueType> generator) {
		_generator = generator;
	}
	
	public boolean hasNext() {
		return _generator.hasNext();
	}

	public ValueType next() {
		return _generator.next();
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

}
