package edu.uiuc.edsg;

/**
 * "Leaf" of an iteration link tree. Advances a child generator when iterated.
 */
public class GeneratorLink implements IIterationLink {
	
	private IGenerator _innerGenerator;
	
	public GeneratorLink(IGenerator innerGenerator) {
		_innerGenerator = innerGenerator;
	}
	
	public IGenerator getInnerGenerator() {
		return _innerGenerator;
	}

	public boolean hasNext() {		
		return _innerGenerator.hasNext();
	}

	public void next() {
		_innerGenerator.next();
	}

	public void reset() {
		_innerGenerator.reset();
	}	
	
	public void accept(IIteratorVisitor visitor) {
		visitor.visit(this);
	}
	
}
