package edu.uiuc.edsg;

/**
 * Interface for a node in a generator iteration tree
 */
public interface IIterationLink extends IVisitableIterator {
	
	/**
	 * @return true if this node can be iterated
	 */
	boolean hasNext();
	
	/**
	 * Iterates this node (and probably children nodes)
	 *
	 */
	void next();
	
	/**
	 * Resets this node (and probably children nodes)
	 *
	 */
	void reset();

	/**
	 * {@inheritDoc}
	 */
	void accept(IIteratorVisitor visitor);
	
}