package edu.uiuc.edsg;

/**
 * Wrapper that wraps another generator's value.
 *
 * @param <ValueType> The type of value that the wrapper returns
 */
public class SimpleWrapper<ValueType> extends Wrapper<ValueType> {

	private IGenerator<ValueType> _target;
	
	public SimpleWrapper(IGenerator<ValueType> target) {
		super(target);
		_target = target;
	}	
	
	@Override	
	protected ValueType getDependentValue() {
		return _target.current();
	}	
}
