package edu.uiuc.edsg.test;

import org.junit.*;

import edu.uiuc.edsg.Converter;
import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.ConversionWrapper;
import edu.uiuc.edsg.samples.PairGenerator;

public class ConversionWrapperTest {

	@Test()
	public void basicConversion() {
		Chain<Integer> target = new Chain<Integer>(1, 2, 3);
		Converter<Integer, String> converter = 
			new Converter<Integer, String>() {
				public String convert(Integer original) {
					// conversion negates the value and turns it into a string
					return String.valueOf(-original.intValue());
				}
			};
		ConversionWrapper<Integer, String> wrapper = 
			new ConversionWrapper<Integer, String>(target, converter);
		
		PairGenerator<String, Integer> pairGen = new PairGenerator<String, Integer>(wrapper, target);
		GeneratorTestUtil.testBasicFunctionality(pairGen, 
				"[-1,1]", 
				"[-2,2]", 
				"[-3,3]");		
	}
	
	//TODO: more comprehensive tests
	
}
