package edu.uiuc.edsg.test;

import org.junit.*;

import edu.uiuc.edsg.ConvertingGenerator;
import edu.uiuc.edsg.FilteredCompositeGenerator;
import edu.uiuc.edsg.GeneratorLink;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.samples.IntegerRangeGenerator;

public class FilteredCompositeGeneratorTest {

	@Test
	public void testBasic() {
		FilteredCompositeGenerator<Integer> filteredGen = new FilteredCompositeGenerator<Integer>() {
			IntegerRangeGenerator innerGen = new IntegerRangeGenerator(0,5);
			
			@Override
			protected IIterationLink getInitializedIterator() {
				return new GeneratorLink(innerGen);
			}
			
			@Override
			protected boolean iterationIsValid() {
				return innerGen.current() % 2 == 0;
			}
			
			@Override
			protected Integer generateCurrent() {
				return innerGen.current();
			}
		};
		
		GeneratorTestUtil.testBasicFunctionality(filteredGen, "0", "2", "4");		
	}
}
