package edu.uiuc.edsg.test.samples;


import org.junit.*;

import edu.uiuc.edsg.*;
import edu.uiuc.edsg.samples.Tree;
import edu.uiuc.edsg.samples.TreeGenerator;
import edu.uiuc.edsg.samples.TreeGenerator.ValueGenCallback;

public class TreeGeneratortest {

	@Test
	public void demo() {		
		// create tree generator
		TreeGenerator<Integer> treeGen = 
			new TreeGenerator<Integer>(
					new ValueGenCallback<Integer>() {
						public IGenerator<Integer> newValueGenerator() {
							return new Choose<Integer>(new Integer[] {1, 2, 3, 4, 5});
						}
					}, 
					4);
		
		int count = 0;
		for (Tree tree : treeGen) {
			System.out.println("Tree #" + ++count);
			System.out.println(tree.toString());
		}
		
		Assert.assertEquals("Wrong number of trees found", 676, count);
	}
}
