package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Block;
import org.eclipse.jdt.core.dom.CatchClause;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ForStatement;
import org.eclipse.jdt.core.dom.SingleVariableDeclaration;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.LinkCreator;

public class CatchClauseGenerator extends ASTNodeGeneratorBase<CatchClause>{
	private ASTNodeGeneratorBase<SingleVariableDeclaration> variableExceptionDeclaration;
	private ASTNodeGeneratorBase<Block> blockDeclaration;
	
	public CatchClauseGenerator(
			ASTNodeGeneratorBase<SingleVariableDeclaration> variableGen, 
			ASTNodeGeneratorBase<Block> blockGen) {
		super();
		variableExceptionDeclaration = variableGen;
		blockDeclaration = blockGen;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator lc = new LinkCreator(LinkCreator.LinkType.COMBINATORIC);
		lc.add(variableExceptionDeclaration);
		lc.add(blockDeclaration);		
		return lc.getLink();
	}
	
	@Override
	protected CatchClause generateCurrent() {
		CatchClause catchClause = super.getAST().newCatchClause();
		catchClause.setBody(blockDeclaration.current());
		catchClause.setException(variableExceptionDeclaration.current());
		return catchClause;
	}

}
