package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Name;
import org.eclipse.jdt.core.dom.SimpleName;
import org.eclipse.jdt.core.dom.StringLiteral;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.IGenerator;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.LinkCreator;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class StringLiteralGenerator extends ASTNodeGeneratorBase<StringLiteral>{
	private IGenerator<String> escapedValue;

	public StringLiteralGenerator (IGenerator<String> escapedValueGen) {
		super();
		escapedValue = escapedValueGen;
	}
	
	@Override
	protected StringLiteral generateCurrent() {		
		StringLiteral stringLiteral = super.getAST().newStringLiteral();		
		stringLiteral.setEscapedValue(escapedValue.current());
		return stringLiteral;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator linkCreator = new LinkCreator(LinkCreator.LinkType.COMBINATORIC);
		linkCreator.add(escapedValue);
		return linkCreator.getLink();
		
	}
	
	public static StringLiteralGenerator getNewDefaultStringLiteralGenerator(){
		Chain<String> chainOfStrings = new Chain<String>();
		chainOfStrings.add("\"name1\"");
		chainOfStrings.add("\"name2\"");
		StringLiteralGenerator stringLiteralGen = new StringLiteralGenerator(chainOfStrings);
		GeneratorTestUtil.testBasicFunctionality(stringLiteralGen, 2);	
		return stringLiteralGen;
	}

}
