package edu.uiuc.astgen.methodrelationships;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.SingleVariableDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.CompositeGenerator;
import edu.uiuc.edsg.IGenerator;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.LinkCreator;

public class MethodRelationshipBuilderGenerator extends CompositeGenerator<MethodRelationshipBuilder> {
	
	private Chain<MethodRelationshipBuilder> builderChain;
	
	@Override
	protected IIterationLink getInitializedIterator() {
		builderChain = new Chain<MethodRelationshipBuilder>();
		builderChain.add(new SeparateBuilder());
		builderChain.add(new OverloadAddBuilder());
		builderChain.add(new OverloadRemoveBuilder());
		builderChain.add(new OverrideBuilder());
		
		return LinkCreator.createCombinatoricLink(builderChain);
	}
	
	@Override
	protected MethodRelationshipBuilder generateCurrent() {
		return builderChain.current();
	}

}
