package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.ConditionalExpressionGenerator;
import edu.uiuc.astgen.basic.InfixExpressionGenerator;
import edu.uiuc.astgen.basic.NumberLiteralGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class ConditionalExpressionGeneratorTest {
	@Test()
	public void DefaultCondtionalExpression() throws Exception {
		GeneratorTestUtil.testBasicFunctionality(ConditionalExpressionGenerator.getNewDefaultConditionalExpressionGenerator(), 8);
	}

	@Test()
	public void SimpleConditionalExpression() throws Exception {
		NumberLiteralGenerator numGen1 = new NumberLiteralGenerator(2, PrimitiveType.BYTE);
		NumberLiteralGenerator numGen2 = new NumberLiteralGenerator(3, PrimitiveType.BYTE);
		
		PrimitiveTypeGenerator primitiveTypeGen = new PrimitiveTypeGenerator(PrimitiveType.BOOLEAN, PrimitiveType.BYTE);		
		SimpleNameGenerator nameGen = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen = new SingleVariableDeclarationGenerator(nameGen, primitiveTypeGen);		
		InfixExpressionGenerator infixGenerator = new InfixExpressionGenerator(variableGen);		
		
		ConditionalExpressionGenerator conditionalExpGen = new ConditionalExpressionGenerator(infixGenerator, numGen1, numGen2);
		GeneratorTestUtil.testBasicFunctionality(conditionalExpGen, 12);
	}		
}
