package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.*;

import edu.uiuc.astgen.basic.NumberLiteralGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.VariableDeclarationFragmentGenerator;
import edu.uiuc.edsg.*;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class VariableDeclarationFragmentGeneratorTest {

	@Test()
	public void basicFunctionality() {
		VariableDeclarationFragmentGenerator vdfg = new VariableDeclarationFragmentGenerator(
				new SimpleNameGenerator(new Chain<String>("var1", "var2")));
		
		GeneratorTestUtil.testBasicFunctionality(vdfg, 2);
	}
	
	@Test()
	public void basicFunctionalityWithInitializer() {
		VariableDeclarationFragmentGenerator vdfg = new VariableDeclarationFragmentGenerator(
				new SimpleNameGenerator(new Chain<String>("var1", "var2")));
		NumberLiteralGenerator numberLiteralGenerator = new NumberLiteralGenerator(3, PrimitiveType.BYTE);
		vdfg.setOptionalInitializer(numberLiteralGenerator);		
		GeneratorTestUtil.testBasicFunctionality(vdfg, 6);
	}
	
	@Test()
	public void basicFunctionalityWithInitializer2() {
		VariableDeclarationFragmentGenerator vdfg = new VariableDeclarationFragmentGenerator(
				new SimpleNameGenerator(new Chain<String>("var1")));
		NumberLiteralGenerator numberLiteralGenerator = new NumberLiteralGenerator(1, PrimitiveType.BYTE);
		vdfg.setOptionalInitializer(numberLiteralGenerator);		
		GeneratorTestUtil.testBasicFunctionality(vdfg, 1);
	}		
}
