package edu.uiuc.astgen.test.nestedexpressions;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Name;
import org.junit.Test;

import edu.uiuc.astgen.nestedexpressions.NestedExpressionGenerator;
import edu.uiuc.astgen.nestedexpressions.OperandType;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class NestedExpressionGeneratorTest {

	AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test
	public void testNumeric() {		
		NestedExpressionGenerator exprGen = new NestedExpressionGenerator();
		exprGen.setTargetExpressionGen(new Chain<Expression>(ast.newSimpleName("target")));
		exprGen.setDummyVariableGen(new Chain<Name>(ast.newSimpleName("dummy")));
		exprGen.setOperandType(OperandType.NUMERIC);
		
		GeneratorTestUtil.testBasicFunctionality(exprGen, 103);
	}
	
	@Test
	public void testBoolean() {		
		NestedExpressionGenerator exprGen = new NestedExpressionGenerator();
		exprGen.setTargetExpressionGen(new Chain<Expression>(ast.newSimpleName("target")));
		exprGen.setDummyVariableGen(new Chain<Name>(ast.newSimpleName("dummy")));
		exprGen.setOperandType(OperandType.BOOLEAN);
		
		GeneratorTestUtil.testBasicFunctionality(exprGen, 44);
	}
	
	@Test
	public void testObject() {		
		NestedExpressionGenerator exprGen = new NestedExpressionGenerator();
		exprGen.setTargetExpressionGen(new Chain<Expression>(ast.newSimpleName("target")));
		exprGen.setDummyVariableGen(new Chain<Name>(ast.newSimpleName("dummy")));
		exprGen.setOperandType(OperandType.OBJECT);
		
		GeneratorTestUtil.testBasicFunctionality(exprGen, 18);
	}
}
